InitSprite()
InitSprite3D()


Enumeration
 #Window
 #Light
EndEnumeration


 IncludeFile "Line2D.pbi"


OpenWindow(#Window, 0, 0, 800, 600, "Screen", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(#Window), 0, 0, WindowWidth(#Window), WindowHeight(#Window), 0, 0, 0)
 
 Sprite3DQuality(1) 
  
 CreateSprite(#Light, 4, 4, #PB_Sprite_Texture)
 StartDrawing(SpriteOutput(#Light))
  Box(0,1,4,2,$FFFFFF)
 StopDrawing()
 CreateSprite3D(#Light, #Light)


Structure OpticalDevice
 Line2D.Line2D  ; Strecke
 Transmission.f ; Transmissionfaktor
 Reflection.f   ; Reflexionsfaktor
 Refraction.f   ; Brechungsindex
 Norm.Vector2D
EndStructure
  
Global NewList OpticalDevice.OpticalDevice()  


Structure LightBeam
 Line2D.Line2D  ; Strecke
 Intensity.f    ; Intensitt
 Temp.i
EndStructure

Global NewList LightBeam.LightBeam() 
 
 
Procedure AddOpticalDevice(x1.f, y1.f, x2.f, y2.f, Transmission.f, Reflection.f, Refraction.f)
 AddElement(OpticalDevice())
 With OpticalDevice()
  \Line2D\Position\x  = x1
  \Line2D\Position\y  = y1
  \Line2D\Direction\x = x2-x1
  \Line2D\Direction\y = y2-y1
  \Transmission       = Transmission
  \Reflection         = Reflection 
  \Refraction         = Refraction
  Vector2DNorm(\Line2D\Direction, \Norm)
 EndWith
EndProcedure 
 
#LightBeamLength = 10000
#MinLightIntensity = 0.01

Procedure AddLightBeam(x.f, y.f, Angle.f, Intensity.f=1.0)
 AddElement(LightBeam())
 With LightBeam()
  \Line2D\Position\x  = x
  \Line2D\Position\y  = y
  \Line2D\Direction\x = #LightBeamLength*Cos(Radian(Angle))
  \Line2D\Direction\y = #LightBeamLength*Sin(Radian(Angle))
  \Intensity = Intensity
 EndWith
EndProcedure

 ; Korregiert einen Winkel in das standard Intervall
 Procedure.f RealAngle(Angle.f)
  If Angle < 0
   ProcedureReturn Mod(Angle, #PI*2) + #PI*2 
  Else
   ProcedureReturn Mod(Angle, #PI*2)
  EndIf
 EndProcedure
 

 ; Gibt den Winkelunterschied zurck
 Procedure.f AngleDifference(Angle1.f, Angle2.f)
  Protected Distance.f
  Angle1 = RealAngle(Angle1)
  Angle2 = RealAngle(Angle2)
  Distance = Angle2 - Angle1
  If Distance > #PI
   Distance - #PI*2
  ElseIf Distance < -#PI
   Distance + #PI*2
  EndIf
  ProcedureReturn Distance
 EndProcedure



Procedure UpdateLightBeam(*LightBeam.LightBeam)
 Protected Distance.f, minDistance.f = Infinity()
 Protected Point2D.Vector2D, OpticalPoint.Vector2D
 Protected *OpticalDevice.OpticalDevice
 ForEach OpticalDevice()
  If OpticalDevice() <> *LightBeam\Temp And CollisionLine2DLine2D(*LightBeam\Line2D, OpticalDevice()\Line2D, Point2D)
   Distance = Distance2D(*LightBeam\Line2D\Position, Point2D)
   If Distance < minDistance
    minDistance = Distance
    OpticalPoint = Point2D
    *OpticalDevice = @OpticalDevice()
   EndIf
  EndIf
 Next
 If *OpticalDevice
  Protected NewDirection.Vector2D
  Vector2DSub(OpticalPoint, *LightBeam\Line2D\Position, *LightBeam\Line2D\Direction)
  If *OpticalDevice\Reflection
    AddElement(LightBeam())
   LightBeam()\Line2D\Position = OpticalPoint
   Vector2DMul(*OpticalDevice\Norm, Vector2DScalar(*OpticalDevice\Norm,*LightBeam\Line2D\Direction)*2, LightBeam()\Line2D\Direction)
   MoveVector2D(LightBeam()\Line2D\Direction, -*LightBeam\Line2D\Direction)
   LengthVector2D(LightBeam()\Line2D\Direction, #LightBeamLength)
   LightBeam()\Intensity = *LightBeam\Intensity * *OpticalDevice\Reflection
   LightBeam()\Temp = *OpticalDevice
   If LightBeam()\Intensity > #MinLightIntensity
    UpdateLightBeam(LightBeam())
   EndIf
  EndIf 
  If *OpticalDevice\Transmission
   AddElement(LightBeam())
   LightBeam()\Line2D\Position = OpticalPoint
   Protected OpticalAngle.f
   Vector2DToAngle(*OpticalDevice\Line2D\Direction, OpticalAngle)
   Protected LightAngle.f
   Vector2DToAngle(*LightBeam\Line2D\Direction, LightAngle)
   Protected NewAngle.f, Angle.f
   Angle = AngleDifference(OpticalAngle, LightAngle)
   If Angle > 0
    NewAngle.f = #PI-ASin(Sin(Angle-#PI/2)/*OpticalDevice\Refraction)
   Else
    NewAngle.f = ASin(Sin(Angle-#PI/2)**OpticalDevice\Refraction)
   EndIf
   If IsNAN(NewAngle)
    AngleToVector2D(OpticalAngle*2-LightAngle, LightBeam()\Line2D\Direction)
   Else
    AngleToVector2D(OpticalAngle-#PI/2-NewAngle, LightBeam()\Line2D\Direction)
   EndIf
   LengthVector2D(LightBeam()\Line2D\Direction, #LightBeamLength)
   LightBeam()\Intensity = *LightBeam\Intensity * *OpticalDevice\Transmission
   LightBeam()\Temp = *OpticalDevice
   If LightBeam()\Intensity > #MinLightIntensity
    UpdateLightBeam(LightBeam())
   EndIf
  EndIf 
 EndIf
EndProcedure
 
Procedure UpdateOpticalWorld()
 ForEach LightBeam()
  If LightBeam()\Temp 
   DeleteElement(LightBeam())
  Else
   LengthVector2D(LightBeam()\Line2D\Direction, #LightBeamLength)
  EndIf
 Next
 ForEach LightBeam()
  UpdateLightBeam(LightBeam())
 Next
EndProcedure 
 
 

 Procedure DisplayTransformSprite3D(Sprite3D, x.f, y.f, Width.f, Height.f, *Vector2D.Vector2D, xCenter.f=0, yCenter.f=0, Transparency=255) 
  Protected Sin.f = *Vector2D\y, Cos.f = *Vector2D\x
  TransformSprite3D(Sprite3D, x+Cos*(-Width*0.5+xCenter) - Sin*(-Height*0.5+yCenter), y+Sin*(-Width*0.5+xCenter) + Cos*(-Height*0.5+yCenter), x+Cos*( Width*0.5+xCenter) - Sin*(-Height*0.5+yCenter), y+Sin*( Width*0.5+xCenter) + Cos*(-Height*0.5+yCenter), x+Cos*( Width*0.5+xCenter) - Sin*( Height*0.5+yCenter), y+Sin*( Width*0.5+xCenter) + Cos*( Height*0.5+yCenter), x+Cos*(-Width*0.5+xCenter) - Sin*( Height*0.5+yCenter), y+Sin*(-Width*0.5+xCenter) + Cos*( Height*0.5+yCenter))
  DisplaySprite3D(Sprite3D, 0, 0, Transparency) 
 EndProcedure 
 
Procedure DisplayLightBeam(*LightBeam.LightBeam)  
 With *LightBeam
  Protected Vector2D.Vector2D, Length = Vector2DLength(\Line2D\Direction) 
  Vector2DNorm(\Line2D\Direction, Vector2D) 
  DisplayTransformSprite3D(#Light, \Line2D\Position\x, \Line2D\Position\y, Length, 4, Vector2D, Length*0.5, 0, 255*\Intensity) 
 EndWith
EndProcedure 
 
  
AddLightBeam(50,  50, 30, 1) 
AddLightBeam(750,  550, 220, 1) 

UpdateOpticalWorld()
 
Procedure DrawOpticalDevice(*OpticalDevice.OpticalDevice)
 Protected n.Vector2D, Length = Vector2DLength(*OpticalDevice\Line2D\Direction)
 DrawLine2D(*OpticalDevice\Line2D, $00FF00)
 Vector2DRotate(*OpticalDevice\Line2D\Direction, #PI/3, n)
 LengthVector2D(n, 10)
 For i = 0 To Length Step 20
  x.f = *OpticalDevice\Line2D\Position\x + *OpticalDevice\Line2D\Direction\x*i/Length
  y.f = *OpticalDevice\Line2D\Position\y + *OpticalDevice\Line2D\Direction\y*i/Length
  LineXY(x, y, x+n\x, y+n\y, $008000)
 Next 
EndProcedure
 
Repeat

 ClearScreen(0)
 
 Start3D()
 
  Sprite3DBlendingMode(5, 2)
  ForEach LightBeam() : With LightBeam()
   DisplayLightBeam(LightBeam())
  EndWith : Next
 
 Stop3D()

 StartDrawing(ScreenOutput())
  DrawingMode(1)
  ForEach OpticalDevice() : With OpticalDevice()
   DrawOpticalDevice(OpticalDevice())
  EndWith : Next
 StopDrawing()
 
 ClearList(OpticalDevice())
 Time.f = Sin(ElapsedMilliseconds()*0.0005)*0.3+#PI/2
 AddOpticalDevice(500, 100, 400+Cos(Time)*400, 100+Sin(Time)*400, 0.5, 0.5, 2.0)
 AddOpticalDevice(400+Cos(Time)*400, 100+Sin(Time)*400, 300, 100, 0.5, 0.5, 2.0)
 AddOpticalDevice(300, 100, 500, 100, 0.5, 0.5, 2.0)
 
 UpdateOpticalWorld()

 FlipBuffers()

Until WindowEvent() = #PB_Event_CloseWindow
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 10
; EnableXP